import Tkinter as tk
import ttk
import example as m

def create_main_window():
    root = tk.Tk()
    root.title("Feet to Meters")
    main_frame = create_frame(root, col = 0, r = 0, st = (tk.N, tk.W, tk.E, tk.S))
    feet_val, feet_entry = create_entry(main_frame, col = 2, r = 1, st = (tk.W, tk.E), w = 7)
    meters = create_label(main_frame, col = 2, r = 2, st = (tk.W, tk.E))
    calculate = update_value(feet_val, meters, m.convert_feet_to_meters)
    create_button(main_frame, text = "Convert!", com = calculate,
            col = 3, r = 3, st = tk.W)
    create_label(main_frame, text = "feet", col = 3, r = 1, st = tk.W)
    create_label(main_frame, text = "is equivalent to", col = 1, r = 2, st = tk.E)
    create_label(main_frame, text = "meters", col = 3, r = 2, st = tk.W)
    for child in main_frame.winfo_children():
        child.grid_configure(padx=5, pady=5)

    feet_entry.focus()
    root.mainloop()


def create_frame(parent, col, r, st):
    frame = ttk.Frame(parent, padding="3 3 12 12")
    frame.grid(column=col, row=r, sticky=st)
    frame.columnconfigure(0, weight=1)
    frame.rowconfigure(0, weight=1)
    return frame

def create_entry(parent, col, r, st, w):
    val = tk.StringVar()
    entry = ttk.Entry(parent, width=w, textvariable=val)
    entry.grid(column=col, row=r, sticky=st)
    return val, entry

def create_label(parent, col, r, st, text = None):
    if text == None:
        val = tk.StringVar()
        label = ttk.Label(parent, textvariable = val)
    else:
        label = ttk.Label(parent, text = text)
        val = None
    label.grid(column = col, row = r, sticky = st)
    return val

def create_button(parent, col, r, st, com, text):
    button = ttk.Button(parent, text = text, command = com)
    button.grid(column = col, row = r, sticky = st)

def update_value(feetVar, metersVar, fun):
    def f():
        metersVar.set(fun(feetVar.get()))
    return f

create_main_window()
